<?php

namespace Litecms\Subcriber\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Litecms\Subcriber\Interfaces\SubscribeRepositoryInterface;

class SubscribePublicController extends BaseController
{
    // use SubscribeWorkflow;

    /**
     * Constructor.
     *
     * @param type \Litecms\Subscribe\Interfaces\SubscribeRepositoryInterface $subscribe
     *
     * @return type
     */
    public function __construct(SubscribeRepositoryInterface $subscribe)
    {
        $this->repository = $subscribe;
        parent::__construct();
    }

    /**
     * Show subscribe's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $subscribes = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();


        return $this->response->title(trans('$subcriber::$subscribe.names'))
            ->view('$subcriber::public.subscribe.index')
            ->data(compact('$subscribes'))
            ->output();
    }

    /**
     * Show subscribe's list based on a type.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function list($type = null)
    {
        $subscribes = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();


        return $this->response->title(trans('$subcriber::$subscribe.names'))
            ->view('$subcriber::public.subscribe.index')
            ->data(compact('$subscribes'))
            ->output();
    }

    /**
     * Show subscribe.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $subscribe = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->response->title($$subscribe->name . trans('$subcriber::$subscribe.name'))
            ->view('$subcriber::public.subscribe.show')
            ->data(compact('$subscribe'))
            ->output();
    }

}
