<?php

namespace Litecms\Subcriber\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class SubscribeTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Subcriber\Models\Subscribe $subscribe)
    {
        return [
            'id'                => $subscribe->getRouteKey(),
            'key'               => [
                'public'    => $subscribe->getPublicKey(),
                'route'     => $subscribe->getRouteKey(),
            ], 
            'sub_id'            => $subscribe->sub_id,
            'sub_email'         => $subscribe->sub_email,
            'url'               => [
                'public'    => trans_url('subcriber/'.$subscribe->getPublicKey()),
                'user'      => guard_url('subcriber/subscribe/'.$subscribe->getRouteKey()),
            ], 
            'status'            => trans('app.'.$subscribe->status),
            'created_at'        => format_date($subscribe->created_at),
            'updated_at'        => format_date($subscribe->updated_at),
        ];
    }
}